<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSalesRep ArrayType
 * @subpackage Arrays
 */
class ArrayOfSalesRep extends AbstractStructArrayBase
{
    /**
     * The SalesRep
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\SalesRep[]
     */
    public $SalesRep;
    /**
     * Constructor method for ArrayOfSalesRep
     * @uses ArrayOfSalesRep::setSalesRep()
     * @param \eBizCharge\StructType\SalesRep[] $salesRep
     */
    public function __construct(array $salesRep = array())
    {
        $this
            ->setSalesRep($salesRep);
    }
    /**
     * Get SalesRep value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\SalesRep[]|null
     */
    public function getSalesRep()
    {
        return isset($this->SalesRep) ? $this->SalesRep : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSalesRep method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSalesRep method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSalesRepForArrayConstraintsFromSetSalesRep(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSalesRepSalesRepItem) {
            // validation for constraint: itemType
            if (!$arrayOfSalesRepSalesRepItem instanceof \eBizCharge\StructType\SalesRep) {
                $invalidValues[] = is_object($arrayOfSalesRepSalesRepItem) ? get_class($arrayOfSalesRepSalesRepItem) : sprintf('%s(%s)', gettype($arrayOfSalesRepSalesRepItem), var_export($arrayOfSalesRepSalesRepItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SalesRep property can only contain items of type \eBizCharge\StructType\SalesRep, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SalesRep value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\SalesRep[] $salesRep
     * @return \eBizCharge\ArrayType\ArrayOfSalesRep
     */
    public function setSalesRep(array $salesRep = array())
    {
        // validation for constraint: array
        if ('' !== ($salesRepArrayErrorMessage = self::validateSalesRepForArrayConstraintsFromSetSalesRep($salesRep))) {
            throw new \InvalidArgumentException($salesRepArrayErrorMessage, __LINE__);
        }
        if (is_null($salesRep) || (is_array($salesRep) && empty($salesRep))) {
            unset($this->SalesRep);
        } else {
            $this->SalesRep = $salesRep;
        }
        return $this;
    }
    /**
     * Add item to SalesRep value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\SalesRep $item
     * @return \eBizCharge\ArrayType\ArrayOfSalesRep
     */
    public function addToSalesRep(\eBizCharge\StructType\SalesRep $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\SalesRep) {
            throw new \InvalidArgumentException(sprintf('The SalesRep property can only contain items of type \eBizCharge\StructType\SalesRep, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SalesRep[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\SalesRep|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\SalesRep|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\SalesRep|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\SalesRep|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\SalesRep|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SalesRep
     */
    public function getAttributeName()
    {
        return 'SalesRep';
    }
}
